namespace Turbo.Plugins.LightningMod
{
    public class DemonHunterImpalePlugin : AbstractSkillHandler, ISkillHandler
	{
        public DemonHunterImpalePlugin()
            : base(CastType.BuffSkill, CastPhase.AutoCast, CastPhase.Move, CastPhase.Attack)
        {
            Enabled = false;
        }

        public override void Load(IController hud)
        {
            base.Load(hud);
            AssignedSnoPower = Hud.Sno.SnoPowers.DemonHunter_Impale;

            CreateCastRule()
                .IfInTown().ThenNoCastElseContinue()
                .IfCastingIdentify().ThenNoCastElseContinue()
                .IfCastingPortal().ThenNoCastElseContinue() 
                .IfOnCooldown().ThenNoCastElseContinue()
                .IfCanCastBuff().ThenContinueElseNoCast() 
                .IfCanCastSimple().ThenContinueElseNoCast()
				.IfSpecificBuffIsActive(Hud.Sno.SnoPowers.DemonHunter_Vault).ThenContinueElseNoCast()
				.IfSecondaryResourcePercentageIsBelow(90).ThenContinueElseNoCast()
				.IfSpecificBuffIsAboutToExpire(hud.Sno.SnoPowers.ChainOfShadows, 1, 30, 100).ThenCastElseContinue();
        }
    }
}