namespace Turbo.Plugins.LightningMod
{
    public class DemonHunterVaultPlugin : AbstractSkillHandler, ISkillHandler
    {
        public bool ElusiveRingEnabled { get; set; } = true;
        public bool LifeOnHitEnabled { get; set; } = true;
        public DemonHunterVaultPlugin()
            : base(CastType.BuffSkill, CastPhase.AutoCast, CastPhase.PreAttack)
        {
            Enabled = false;
            ElusiveRingEnabled = false;
            LifeOnHitEnabled = false;
        }

        public override void Load(IController hud)
        {
            base.Load(hud);
            AssignedSnoPower = Hud.Sno.SnoPowers.DemonHunter_Vault;

            CreateCastRule()
                .IfInTown().ThenNoCastElseContinue()
                .IfCastingIdentify().ThenNoCastElseContinue()
                .IfCastingPortal().ThenNoCastElseContinue()
                .IfOnCooldown().ThenNoCastElseContinue()
                .IfCanCastBuff().ThenContinueElseNoCast()
                .IfCanCastSimple().ThenContinueElseNoCast()
                .IfTrue(ctx => ctx.Skill.Player.Stats.ResourceCurDiscipline < 8).ThenNoCastElseContinue()
				.IfEnoughMonstersNearby(ctx => 40, ctx => 1).ThenContinueElseNoCast()
				.IfSpecificBuffIsAboutToExpire(hud.Sno.SnoPowers.ElusiveRing, 1, 30, 100).ThenCastElseContinue();
        }

    }
}